function F = floecount(atomdata,bonds)
% floecount -- groups grains into floes based on bond information
%
% Author: Agnieszka Herman, IOUG (agnieszka.herman@ug.edu.pl)
%
N = length(atomdata.r);
%=== prepare the bond information:
bonds = bonds.entries{1}(:,1:2);
%=== identify floes:
F = zeros(N,1);
waitlist = ones(N,1);
ind = 1;
floeid = 1;
F(ind) = floeid;
waitlist(ind) = 0;
while sum(waitlist > 0)
    new = 1;
    while new==1
        new = 0;
        inc1 = [];
        inc2 = [];
        for n = 1:length(ind)
            tmp = find(bonds(:,1)==atomdata.id(ind(n)));
            inc1 = [inc1; tmp];
            tmp = find(bonds(:,2)==atomdata.id(ind(n)));
            inc2 = [inc2; tmp];
        end
        ids = unique([bonds(inc1,2);bonds(inc2,1)]);
        bonds(union(inc1,inc2),:) = [];        
        if ~isempty(ids)
            [~,ind] = intersect(atomdata.id,ids);
            F(ind) = floeid;
            waitlist(ind) = 0;
            new = 1;
        end
    end
    floeid = floeid + 1;
    ind = find(waitlist==1,1,'first');
    F(ind) = floeid;
    waitlist(ind) = 0;
end
%=== sort floes according to the number of grains:
Nf = histc(F,1:max(F));
[~,ix] = sort(Nf,'descend');
Fsort = zeros(size(F));
for n = 1:length(ix)
    Fsort(F==ix(n)) = n;
end
F = Fsort;
